SoMaterialBinding(3)

NAME
SoMaterialBinding - The SoMaterialBinding class is a node for setting up how materials are mapped to shapes.

SYNOPSIS

#include <Inventor/nodes/SoMaterialBinding.h>

Inherits SoNode.

  Public Types
enum Binding { OVERALL = SoMaterialBindingElement::OVERALL, PER_PART = SoMaterialBindingElement::PER_PART, PER_PART_INDEXED = SoMaterialBindingElement::PER_PART_INDEXED, PER_FACE = SoMaterialBindingElement::PER_FACE, PER_FACE_INDEXED = SoMaterialBindingElement::PER_FACE_INDEXED, PER_VERTEX = SoMaterialBindingElement::PER_VERTEX, PER_VERTEX_INDEXED = SoMaterialBindingElement::PER_VERTEX_INDEXED, DEFAULT = OVERALL, NONE = OVERALL }

  Public Member Functions
virtual SoType getTypeId (void) const
SoMaterialBinding (void)
virtual void doAction (SoAction *action)
virtual void GLRender (SoGLRenderAction *action)
virtual void callback (SoCallbackAction *action)
virtual void pick (SoPickAction *action)
virtual void getPrimitiveCount (SoGetPrimitiveCountAction *action)

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFEnum value

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoMaterialBinding ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoMaterialBinding class is a node for setting up how materials are mapped to shapes. The material binding specified in nodes of this type decides how the material values of SoMaterial nodes are mapped on the built-in geometry shape nodes.

The exact meaning of a binding depends on what particular shape type a material or a set of materials are applied to.

Here is a very simple usage example:

#Inventor V2.1 ascii
Separator {
   Coordinate3 {
      point [ 0 0 0, 1 0 0, 1 1 0 ]
   }
   Material {
      diffuseColor [ 1 0 0, 1 1 0, 0 0 1 ]
   }
   MaterialBinding {
      value PER_VERTEX_INDEXED
   }
   IndexedFaceSet {
      coordIndex [ 0, 1, 2, -1 ]
      materialIndex [ 0, 1, 0 ]
   }
}

With SoMaterialBinding::value set to PER_VERTEX_INDEXED above, the material indices will be taken from the SoIndexedFaceSet::materialIndex field when rendering.

If SoMaterialBinding::value was set to PER_VERTEX_INDEXED as above, and the SoIndexedFaceSet::materialIndex was undefined or empty, indices would implicitly be taken from the SoIndexedFaceSet::coordIndex field.

If SoMaterialBinding::value is set to PER_VERTEX, colors will be fetched in a monotonically increasing manner from the SoMaterial::diffuseColor field, starting at index 0.

FILE FORMAT/DEFAULTS:

MaterialBinding {
    value OVERALL
}

See also
    SoMaterial

Member Enumeration Documentation

  enum SoMaterialBinding::Binding
Enumeration of available types of material binding.

Enumerator

OVERALL
    Apply the same material to the complete shape.

PER_PART
    Get a new material from the pool of material values for each part of the shape, where the definition of a part depends on the shape type.

Materials are fetched from index 0 and onwards, incrementing the index into the material pool by 1 for each new part in the order defined by the particular shape type.

Important portability note: it was previously allowed with the SGI Inventor library to supply too few colors versus the number of parts of the subsequent shapes in the scene graph. Coloring would then cycle through the available colors.

Since SGI Open Inventor v2.1, this was disallowed, though -- enough colors for all parts must be supplied, or behavior will be unspecified (likely to cause a crash, in fact). Note that the Inventor Mentor book contains a description of the old, invalid behavior in Chapter 5, section 'Binding Nodes' (middle of page 128 in the 10th printing).

PER_PART_INDEXED
    Get a new material from the pool of material values for each part of the shape, where the definition of a part depends on the shape type.

Materials are fetched by the index value settings of the shape.

PER_FACE
    Get a new material from the pool of material values for each polygon face of the shape.

Materials are fetched from index 0 and onwards, incrementing the index into the material pool by 1 for each new face of the shape node.

Note that individual faces after tessellation of complex shapes (like SoCylinder nodes) are not considered to be separate entities, and so this binding will be treated in the same manner as SoMaterialBinding::PER_PART for those.

PER_FACE_INDEXED
    Get a new material from the pool of material values for each polygon face of the shape.

Materials are fetched by the index value settings of the shape.

Note that individual faces after tessellation of complex shapes (like SoCylinder nodes) are not considered to be separate entities, and so this binding will be treated in the same manner as SoMaterialBinding::PER_PART_INDEXED for those.

PER_VERTEX
    Get a new material from the pool of material values for each polygon, line or point vertex of the shape.

Materials are fetched from index 0 and onwards, incrementing the index into the material pool by 1 for each new vertex of the shape node.

PER_VERTEX_INDEXED
    Get a new material from the pool of material values for each polygon, line or point vertex of the shape.

Materials are fetched by the index value settings of the shape.

DEFAULT
    Obsolete. Don't use this value.

NONE
    Obsolete. Don't use this value.

Constructor & Destructor Documentation

  SoMaterialBinding::SoMaterialBinding (void)
Constructor.

  SoMaterialBinding::~SoMaterialBinding () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoMaterialBinding::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoMaterialBinding::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Implements SoBase.

  const SoFieldData ** SoMaterialBinding::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoMaterialBinding::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoFieldContainer.

  void SoMaterialBinding::doAction (SoAction * action) [virtual]
This function performs the typical operation of a node for any action.

Reimplemented from SoNode.

  void SoMaterialBinding::GLRender (SoGLRenderAction * action) [virtual]
Action method for the SoGLRenderAction.

This is called during rendering traversals. Nodes influencing the rendering state in any way or want to throw geometry primitives at OpenGL override this method.

Reimplemented from SoNode.

  void SoMaterialBinding::callback (SoCallbackAction * action) [virtual]
Action method for SoCallbackAction.

Simply updates the state according to how the node behaves for the render action, so the application programmer can use the SoCallbackAction for extracting information about the scene graph.

Reimplemented from SoNode.

  void SoMaterialBinding::pick (SoPickAction * action) [virtual]
Action method for SoPickAction.

Does common processing for SoPickAction action instances.

Reimplemented from SoNode.

  void SoMaterialBinding::getPrimitiveCount (SoGetPrimitiveCountAction * action) [virtual]
Action method for the SoGetPrimitiveCountAction.

Calculates the number of triangle, line segment and point primitives for the node and adds these to the counters of the action.

Nodes influencing how geometry nodes calculate their primitive count also override this method to change the relevant state variables.

Reimplemented from SoNode.

Member Data Documentation

  SoSFEnum SoMaterialBinding::value
The material binding to use for subsequent shape nodes in the scene graph. The default binding is SoMaterialBinding::OVERALL.

Author

Generated automatically by Doxygen for Coin from the source code.